﻿// AgentDllTesterDlg.cpp : 구현 파일
//

#include "stdafx.h"
#include "AgentDllTester.h"
#include "AgentDllTesterDlg.h"
#include "command.h"
#include "tinyxml.h"
#include "XMLUtil.h"
#include "HttpClient/httpclient.h"
#include "atlstr.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// 응용 프로그램 정보에 사용되는 CAboutDlg 대화 상자입니다.

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// 대화 상자 데이터입니다.
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV 지원입니다.

// 구현입니다.
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CAgentDllTesterDlg 대화 상자




CAgentDllTesterDlg::CAgentDllTesterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAgentDllTesterDlg::IDD, pParent)
	, m_CurrentAgentDLL(_T(""))
	, m_currentRequest(_T(""))
	, m_currentResponse(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_func = NULL;
	m_agentdll = NULL;
	m_CurrentAgentDLLIndex = -1;
	m_currentResultIndex = -1;
}

void CAgentDllTesterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_AGENTDLLLIST, m_AgentdllLists);
	DDX_Control(pDX, IDC_RESULT, m_result_lists);
	DDX_Text(pDX, IDC_CURRENT_AGENTDLL, m_CurrentAgentDLL);
	DDX_Text(pDX, IDC_AGENT_REQUEST, m_currentRequest);
	DDX_Text(pDX, IDC_AGENT_RESPONSE, m_currentResponse);
}

BEGIN_MESSAGE_MAP(CAgentDllTesterDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, &CAgentDllTesterDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDC_COMMAND_GUID_BUTTON, &CAgentDllTesterDlg::OnBnClickedCommandGuidButton)
	ON_BN_CLICKED(IDC_COMMAND_ISINSTALLED_BUTTON, &CAgentDllTesterDlg::OnBnClickedCommandIsinstalledButton)
	ON_BN_CLICKED(IDC_COMMAND_ISCHANGED_BUTTON, &CAgentDllTesterDlg::OnBnClickedCommandIschangedButton)
	ON_BN_CLICKED(IDC_COMMAND_ISSHOW_BUTTON, &CAgentDllTesterDlg::OnBnClickedCommandIsshowButton)
	ON_BN_CLICKED(IDC_COMMAND_URL_BUTTON, &CAgentDllTesterDlg::OnBnClickedCommandUrlButton)
	ON_BN_CLICKED(IDC_COMMAND_SHOWN_BUTTON, &CAgentDllTesterDlg::OnBnClickedCommandShownButton)
	ON_BN_CLICKED(IDC_COMMAND_RUN_BUTTON, &CAgentDllTesterDlg::OnBnClickedCommandRunButton)
	ON_BN_CLICKED(IDC_COMMAND_STATUS_BUTTON, &CAgentDllTesterDlg::OnBnClickedCommandStatusButton)
	ON_BN_CLICKED(IDC_COMMAND_INSTALLL_ERROR_BUTTON, &CAgentDllTesterDlg::OnBnClickedCommandInstalllErrorButton)
	ON_BN_CLICKED(IDC_COMMAND_UNINSTALLER_ERROR_BUTTON, &CAgentDllTesterDlg::OnBnClickedCommandUninstallerErrorButton)
	ON_BN_CLICKED(IDC_COMMAND_UNINSTALLER_URL_BUTTON, &CAgentDllTesterDlg::OnBnClickedCommandUninstallerUrlButton)
	ON_BN_CLICKED(IDC_COMMAND_LOCAL_BUTTON, &CAgentDllTesterDlg::OnBnClickedCommandLocalButton)
	ON_BN_CLICKED(IDC_COMMAND_RECENT_BUTTON, &CAgentDllTesterDlg::OnBnClickedCommandRecentButton)
	ON_BN_CLICKED(IDC_COMMAND_CLOSE_BUTTON, &CAgentDllTesterDlg::OnBnClickedCommandCloseButton)
	ON_BN_CLICKED(IDC_COMMAND_RELOAD_BUTTON, &CAgentDllTesterDlg::OnBnClickedCommandReloadButton)
	ON_NOTIFY(NM_CLICK, IDC_AGENTDLLLIST, &CAgentDllTesterDlg::OnNMClickAgentdlllist)
	ON_NOTIFY(NM_CLICK, IDC_RESULT, &CAgentDllTesterDlg::OnNMClickResult)
	ON_BN_CLICKED(IDC_DEPLOY_TEST_BUTTON, &CAgentDllTesterDlg::OnBnClickedDeployTestButton)
	ON_BN_CLICKED(IDC_AGREEMENT_TEST_BUTTON, &CAgentDllTesterDlg::OnBnClickedAgreementTestButton)
	ON_BN_CLICKED(IDC_REQUEST_APPLY_BUTTON, &CAgentDllTesterDlg::OnBnClickedRequestApplyButton)
END_MESSAGE_MAP()


// CAgentDllTesterDlg 메시지 처리기

BOOL CAgentDllTesterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// 시스템 메뉴에 "정보..." 메뉴 항목을 추가합니다.

	// IDM_ABOUTBOX는 시스템 명령 범위에 있어야 합니다.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// 이 대화 상자의 아이콘을 설정합니다. 응용 프로그램의 주 창이 대화 상자가 아닐 경우에는
	//  프레임워크가 이 작업을 자동으로 수행합니다.
	SetIcon(m_hIcon, TRUE);			// 큰 아이콘을 설정합니다.
	SetIcon(m_hIcon, FALSE);		// 작은 아이콘을 설정합니다.

	// TODO: 여기에 추가 초기화 작업을 추가합니다.
	ContorlInitialize();
	AgentDLLInit();

	return TRUE;  // 포커스를 컨트롤에 설정하지 않으면 TRUE를 반환합니다.
}

void CAgentDllTesterDlg::ParseAgentDLLInfo(TiXmlElement *pElement)
{
	CString guid;
	CString name;
	CString url;

	TiXmlAttribute *pAttr = pElement->FirstAttribute();
	if( pAttr )
	{
		const char *name = pAttr->Name();
		guid = pAttr->ValueStr().c_str();
	}

	pElement = pElement->FirstChildElement("name");
	if( pElement )
	{
		name = XMLUtil::Decode_utf8(pElement->GetText());
	}

	pElement = pElement->NextSiblingElement("agentdllxml.url");
	if( pElement )
	{
		url = XMLUtil::Decode_utf8(pElement->GetText());
	}

	int nCount = m_AgentdllLists.GetItemCount(); 
	nCount = m_AgentdllLists.InsertItem(nCount, name);
	m_AgentdllLists.SetItemText(nCount, 1, url );
	m_AgentdllLists.SetItemText(nCount, 2, guid );
}
void CAgentDllTesterDlg::AgentDLLInit()
{
	tipbase::GenericHTTPClient httpClient;
	CString initDocumentURL = _T("http://cdn.naver.com/naver/tools/updater/serviceinfo/updater.xml");

	if( httpClient.Request(NULL, initDocumentURL) == TRUE)
	{
		TiXmlDocument xmlDoc;
//		xmlDoc->Parse("<?xml version=\"1.0\" encoding=\"utf-8\"?><root><main><version>0.0.0.6</version></main></root>");
		xmlDoc.Parse((const char*)httpClient.QueryHTTPResponse());
		
		TiXmlNode *pNode = xmlDoc.FirstChild();

		TiXmlElement *pElement = xmlDoc.FirstChildElement("root");
		pElement = pElement->FirstChildElement("service");
		while( pElement )
		{
			ParseAgentDLLInfo(pElement);
			pElement = pElement->NextSiblingElement("service");
		}


		return;
	}
}

void CAgentDllTesterDlg::ContorlInitialize()
{
	m_AgentdllLists.SetExtendedStyle( LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES );
	m_AgentdllLists.InsertColumn( 0, _T("Name"), 0, 80 );
	m_AgentdllLists.InsertColumn( 1, _T("Url"), 0, 500 );
	m_AgentdllLists.InsertColumn( 2, _T("Guid"), 0, 500 );

	m_result_lists.SetExtendedStyle( LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES );
	m_result_lists.InsertColumn( 0, _T("Status"), 0, 50 );
	m_result_lists.InsertColumn( 1, _T("Request"), 0, 115 );
	m_result_lists.InsertColumn( 2, _T("Response"), 0, 115 );

	m_listCtrlAdaptor = new ListCtrlAdaptor(&m_result_lists);
	m_agnetdllcommandlist = new AgentDLLCommandList();
	m_agnetdllcommandlist->SetListCtrlAdaptor(m_listCtrlAdaptor);
}

void CAgentDllTesterDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// 대화 상자에 최소화 단추를 추가할 경우 아이콘을 그리려면
//  아래 코드가 필요합니다. 문서/뷰 모델을 사용하는 MFC 응용 프로그램의 경우에는
//  프레임워크에서 이 작업을 자동으로 수행합니다.

void CAgentDllTesterDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 그리기를 위한 디바이스 컨텍스트

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// 클라이언트 사각형에서 아이콘을 가운데에 맞춥니다.
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// 아이콘을 그립니다.
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// 사용자가 최소화된 창을 끄는 동안에 커서가 표시되도록 시스템에서
//  이 함수를 호출합니다.
HCURSOR CAgentDllTesterDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CAgentDllTesterDlg::OnBnClickedOk()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	m_agnetdllcommandlist->Command();
}

void CAgentDllTesterDlg::OnBnClickedCommandGuidButton()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	AddCommand(_T("guid"));
}

void CAgentDllTesterDlg::OnBnClickedCommandIsinstalledButton()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	AddCommand(_T("isinstalled"));
}

void CAgentDllTesterDlg::OnBnClickedCommandIschangedButton()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	AddCommand(_T("version.ischanged"));
}

void CAgentDllTesterDlg::OnBnClickedCommandIsshowButton()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	AddCommand(_T("agreement.isshow"));
}

void CAgentDllTesterDlg::OnBnClickedCommandUrlButton()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	AddCommand(_T("agreement.url"));
}

void CAgentDllTesterDlg::OnBnClickedCommandShownButton()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	AddCommand(_T("agreement.shown"));
}

void CAgentDllTesterDlg::OnBnClickedCommandRunButton()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	AddCommand(_T("upgrader.run"));
}

void CAgentDllTesterDlg::OnBnClickedCommandStatusButton()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	AddCommand(_T("upgrader.status"));
}

void CAgentDllTesterDlg::OnBnClickedCommandInstalllErrorButton()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	AddCommand(_T("installer.error"));
}

void CAgentDllTesterDlg::OnBnClickedCommandUninstallerErrorButton()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	AddCommand(_T("uninstaller.error"));
}

void CAgentDllTesterDlg::OnBnClickedCommandUninstallerUrlButton()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	AddCommand(_T("uninstaller.url"));
}

void CAgentDllTesterDlg::OnBnClickedCommandLocalButton()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	AddCommand(_T("version.local"));
}

void CAgentDllTesterDlg::OnBnClickedCommandRecentButton()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	AddCommand(_T("version.recent"));
}

void MakeQueryElement(LPCTSTR qid, LONG value, CString &element)
{
	XMLUtil::WriteElementValue(element, qid, value);
}

void MakeQueryElement(LPCTSTR qid, BOOL value, CString &element)
{
	XMLUtil::WriteElementValue(element, qid, value);
}

class AgentDLLCommandClose : public AgentDLLCommand
{
public:
	AgentDLLCommandClose( CAgentDllTesterDlg *dlg ) : AgentDLLCommand(_T("Close"), NULL)
	{
		m_dlg = dlg;
	}

	BOOL CommandImpl()
	{
		m_dlg->CloseAgentDLL();
		return TRUE;
	}

	CAgentDllTesterDlg *m_dlg;
};

class AgentDLLCommandReload : public AgentDLLCommand
{
public:
	AgentDLLCommandReload( CAgentDllTesterDlg *dlg ) : AgentDLLCommand(_T("Reload"), NULL)
	{
		m_dlg = dlg;
	}

	BOOL CommandImpl()
	{
		m_dlg->OpenCurrentAgentDLL();
		return TRUE;
	}

	CAgentDllTesterDlg *m_dlg;
};

class AgentDLLCommandAgreementShown : public AgentDLLCommand
{
public:
	AgentDLLCommandAgreementShown( m_pFuncRequest m_func, BOOL bFlag ) : AgentDLLCommand(_T("agreement.shown"), m_func )
	{
		m_flag = bFlag;
		CString value = _T("");
		MakeQueryElement( _T("value"), bFlag , value );
		char request[1024];
		int size = MakeQueryXML( m_name, value, request, 1024 );
		m_request = request;
	}

	BOOL m_flag;
};



class AgentDLLCommandUpgradeRun : public AgentDLLCommand
{
public:
	AgentDLLCommandUpgradeRun( m_pFuncRequest m_func, LONG type ) : AgentDLLCommand(_T("upgrader.run"), m_func )
	{
		m_type = type;
		CString value = _T("");
		MakeQueryElement( _T("value"), (LONG)type, value );
		char request[1024];
		int size = MakeQueryXML( m_name, value, request, 1024 );
		m_request = request;
	}

	LONG m_type;
};

void CAgentDllTesterDlg::OnBnClickedCommandCloseButton()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	AddCloseCommand();
}

void CAgentDllTesterDlg::OnBnClickedCommandDownloadButton()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
//	AddCommand(_T("version.local"));
}

void CAgentDllTesterDlg::AddCommand(const TCHAR *command, const TCHAR *value)
{
	if( NULL == m_func )
		return;

	AgentDLLCommand *agentCommand = new AgentDLLCommand( command, m_func, value );
	m_agnetdllcommandlist->Add(agentCommand);
}

void CAgentDllTesterDlg::OpenCurrentAgentDLL()
{
	OpenAgentDLL(m_CurrentAgentDLLIndex);
};

void CAgentDllTesterDlg::OpenAgentDLL(int index, BOOL bReset)
{
	CString name = m_AgentdllLists.GetItemText( index, 0 );
	CString url = m_AgentdllLists.GetItemText( index, 1 );
	CString guid = m_AgentdllLists.GetItemText( index, 2 );

	m_CurrentAgentDLL = name;
	m_CurrentAgentDLLIndex = index;
	m_CurrentAgentDLL += _T("{");
	m_CurrentAgentDLL += guid;
	m_CurrentAgentDLL += _T("}");

	CloseAgentDLL();

	m_agentdll = AgentDLLManager::Register(guid, url);
	if( m_agentdll )
	{
		if( bReset )
		{
			m_currentResultIndex = -1;
			m_agnetdllcommandlist->DeleteAll();
		}

		m_func = m_agentdll->GetFuncRequest();

		m_currentRequest = _T("");
		m_currentResponse = _T("");
	}

	UpdateData(FALSE);
}

void CAgentDllTesterDlg::CloseAgentDLL()
{
	if( m_agentdll )
	{
		AgentDLLManager::Unregister(m_agentdll);
		m_agentdll = NULL;
		m_func = NULL;
	}
}

void CAgentDllTesterDlg::OnNMClickAgentdlllist(NMHDR *pNMHDR, LRESULT *pResult)
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	NMLISTVIEW *item = (NMLISTVIEW *)pNMHDR;
	OpenAgentDLL(item->iItem, TRUE);
	*pResult = 0;
}

void CAgentDllTesterDlg::OnNMClickResult(NMHDR *pNMHDR, LRESULT *pResult)
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	NMLISTVIEW *item = (NMLISTVIEW *)pNMHDR;

	m_currentResultIndex = item->iItem;
	AgentDLLCommand *command = (AgentDLLCommand*)m_result_lists.GetItemData( item->iItem );
	if(command)
	{
		TCHAR ch;
		m_currentResponse = _T("");
		CString temp = command->GetResponse(); 
		for( int i = 0; i < temp.GetLength(); i++ )
		{
			m_currentResponse += temp.GetAt(i);
			if( temp.GetAt(i) == '>' )
			{
				ch = temp.GetAt(i+1);
				if ( ch == '\n' )
				{
					m_currentResponse += _T("\r\n");
					i++;
				}
				else if ( ch != '\r' )
				{
					m_currentResponse += _T("\r\n");
				}
			}

		}
		m_currentRequest = command->GetRequest();
	}
	UpdateData(FALSE);
	*pResult = 0;
}

int RequestSEHFunc( m_pFuncRequest func, char *request, char *response, int size)
{
	int ret = -1;
	__try{
		ret = func( request, response, size );
	}
	__except(EXCEPTION_EXECUTE_HANDLER)
	{
		ret = -1;
	}

	return ret;
}

void CAgentDllTesterDlg::AddCloseCommand()
{
	AgentDLLCommandClose *command = new AgentDLLCommandClose( this );
	m_agnetdllcommandlist->Add(command);
}

void CAgentDllTesterDlg::AddReloadCommand()
{
	AgentDLLCommandReload *command = new AgentDLLCommandReload( this );
	m_agnetdllcommandlist->Add(command);
}

void CAgentDllTesterDlg::AddUpgradeRunCommand(BOOL runtype)
{
	AgentDLLCommandUpgradeRun *command = new AgentDLLCommandUpgradeRun( m_func, runtype );
	m_agnetdllcommandlist->Add(command);
}

void CAgentDllTesterDlg::AddAgreementShownCommand(BOOL bFlag)
{
	AgentDLLCommandAgreementShown *command = new AgentDLLCommandAgreementShown( m_func, bFlag );
	m_agnetdllcommandlist->Add(command);
}

void CAgentDllTesterDlg::OnBnClickedCommandReloadButton()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	AddReloadCommand();
}

void CAgentDllTesterDlg::OnBnClickedDeployTestButton()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	if( NULL == m_func )
		return;

	AddCommand(_T("guid"));
	AddCommand(_T("isinstalled"));
	AddCommand(_T("version.ischanged"));
	AddCloseCommand();
	AddReloadCommand();
	AddCommand(_T("guid"));
	AddCommand(_T("isinstalled"));
	AddCommand(_T("version.ischanged"));
	AddUpgradeRunCommand(0);
	AddCommand(_T("version.ischanged"));
}

void CAgentDllTesterDlg::OnBnClickedAgreementTestButton()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	if( NULL == m_func )
		return;

	AddCommand(_T("guid"));
	AddCommand(_T("isinstalled"));
	AddCommand(_T("version.ischanged"));
	AddCloseCommand();
	AddReloadCommand();
	AddCommand(_T("guid"));
	AddCommand(_T("isinstalled"));
	AddCommand(_T("version.ischanged"));
	AddCommand(_T("agreement.isshow"));
	AddCommand(_T("agreement.url"));
	AddAgreementShownCommand(TRUE);
	AddCommand(_T("agreement.isshow"));
	AddUpgradeRunCommand(0);
	AddCommand(_T("version.ischanged"));
}

void CAgentDllTesterDlg::OnBnClickedRequestApplyButton()
{
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	UpdateData(TRUE);
	if( m_currentRequest.IsEmpty() || -1 == m_currentResultIndex )
		return;

	AgentDLLCommand *command = (AgentDLLCommand*)m_result_lists.GetItemData( m_currentResultIndex );
	if( command )
	{
		command->SetRequest(m_currentRequest);
	}
}
